package ru.ifmo.ga;

public class FxTest {

    public static void main(String args[]) {
        Configuration<IntString> cfg = new BitstringConfiguration();
        cfg.setChromosomeLength(50);
        cfg.setPopulationSize(100);
        cfg.setFitness(new Fitness<IntString>() {
            public void fitness(EvalChromosome<IntString>[] pop) {
                for (EvalChromosome<IntString> c : pop) {
                    c.v = fitness(c.c);
                }
            }


            public double fitness(IntString ch) {
                int r = 0;
                for (int b : ch) {
                    if (b == 1) {
                        r++;
                    }
                }
                return r * 1.0 / ch.length();
            }
        });
        Genome ga = Genome.randomize(cfg);
        int step = 0;
        while (ga.getFittest() != 1.0) {
            step++;
            if (step > 10000) {
                throw new RuntimeException();
            }
            ga.evolve();
        }

    }
}
