package ru.ifmo.ga;

import java.io.InputStream;
import java.util.Iterator;

public class IntString implements Iterable<Integer> {
    private final int a[];

    public int length() {
        return a.length;
    }

    public int get(int i) {

        try {
            return a[i];
        } catch (Exception e) {
            throw new RuntimeException(e);
        }
    }

    public void set(int i, int b) {
        a[i] = b;
    }

    public Iterator<Integer> iterator() {
        return new Iterator<Integer>() {
            private int ind = -1;

            public boolean hasNext() {
                return ind < a.length - 1;
            }

            public Integer next() {
                return a[++ind];
            }

            public void remove() {

            }
        };
    }

    public IntString(int[] r) {
        a = r.clone();
    }

    public IntString(int size) {
        a = new int[size];
    }

    public IntString(String s) {
        String[] r = s.split(" ");
        a = new int[r.length];
        for (int i = 0; i < r.length; i++) {
            a[i] = Integer.parseInt(r[i]);
        }
    }

    public String toString() {
        StringBuilder sb = new StringBuilder();
        for (int b : a) {
            sb.append(b).append(" ");
        }
        return sb.toString();
    }

    public void copy(IntString c) {
        System.arraycopy(c.a, 0, a, 0, a.length);
    }

    public InputStream asInputStream() {
        return new InputStream() {
            int pos;

            public int read() {
                return (pos == a.length) ? -1 : a[pos++];
            }
        };
    }


}
