package ru.ifmo.hmm;

import org.apache.log4j.Logger;

public class DataProvider {
    private static Logger LOG = Logger.getLogger(DataProvider.class);

    static final long SEED = 312314159;

    static final int N = 15;
    static final int M = 2;

    static final int KA = 2, KB = -1, KP = 1;
    static final double DA = 0.1, DB = 0, DP = 0;

    static final int LEN = 200;
    static final int SAMPLES = 50;
    
    static final int TRIES = 100000;

    static final int TRAIN[][] = new int[SAMPLES][LEN];

    static Hmm hmm1;
    
    private static final double DELTA = 0.1;

    private static void info() {
        LOG.info("States: " + N);
        LOG.info("Outs: " + M);
        LOG.info("Samples: " + SAMPLES);
        LOG.info("Len: " + LEN);
        LOG.info("Tries: " + TRIES);
        LOG.info("A: " + KA + ", " + DA);
        LOG.info("B: " + KB + ", " + DB);
        LOG.info("P: " + KP + ", " + DP);
    }


    static {
        info();

        hmm1 = new Hmm(N, M);
        hmm1.rndQuasideterm(DA, KA, DELTA);
        hmm1.updateSampling(true);
        for (int i = 0; i < SAMPLES; i++) {
            TRAIN[i] = hmm1.generate(LEN);
        }
        LOG.info("\n" + hmm1.toString());
        double est1 = hmm1.solve1Ln(TRAIN);
        LOG.info("original: " + est1);

        double est2 = hmm1.solve3(TRAIN, 1);
        LOG.info("optimized: " + est2);
    }

}
