package robocode.control;

import ru.ifmo.robocode.EvolvedTank;
import ru.ifmo.robocode.TankManager;
import robocode.Robot;
import robocode.repository.RobotSpec;

import java.io.File;

import sample.Walls;


public class Vis {

    public static final Object mutex = new Object();
    private static final String ROBOTS_DIR = "robots";
    private static final int NUM_ROUNDS = 1000;
    private static final Robot myTank = new EvolvedTank();
    private static final Robot enemyClazz = new Walls();

    private static RobotSpecification getRobot(String clazz) {
        return new RobotSpecification(new RobotSpec(new File(clazz + ".class"), new File(ROBOTS_DIR), "", false));
    }

    public static void main(String[] args) {
        RobocodeEngine engine = new RobocodeEngine(new RobocodeListener() {
            public void battleComplete(BattleSpecification battle, RobotResults[] results, int numTiks, long ticksTime, long robotsTime) {
            }

            public void battleAborted(BattleSpecification battle) {
            }

            public void battleMessage(String message) {
            }
        });

        engine.setVisible(true);

        BattlefieldSpecification bfspec = new BattlefieldSpecification();
        RobotSpecification enemy = getRobot(enemyClazz.getClass().getName());

        RobotSpecification my = getRobot(myTank.getClass().getName());
        TankManager.getInstance().setObjects(false, false);

        RobotSpecification[] rs = {my, enemy};
        BattleSpecification bspec = new BattleSpecification(NUM_ROUNDS, 450, 0.1, bfspec, rs);
        engine.runBattle(bspec);

        synchronized (mutex) {
            try {
                mutex.wait();
            } catch (InterruptedException e) {
                throw new RuntimeException(e);
            }
        }
        engine.close();
    }

}
