package ru.ifmo.robocode;

import ru.ifmo.robocode.gep.Chromosome;

public class Function implements TankControlSystem {

    private final Expression[] expr;

    public double[] execute(double...  s) {
        double [] res = new double[expr.length];
        for (int i = 0; i < res.length; i++) {
            res[i] = expr[i].calc(s);
        }
        return res;
    }

    public Function(Chromosome c, BasisFunc[] func, String[] terms) {
        expr = new Expression[c.f.length];
        for (int i = 0; i < expr.length; i++) {
            expr[i] = new Expression(c.f[i], func, terms);
        }
    }

    public void newRound() {
    }

}
